Index: include/pconn/PConnection.h
===================================================================
RCS file: /var/lib/cvs/coldsync/include/pconn/PConnection.h,v
retrieving revision 1.37
diff -u -B -b -r1.37 PConnection.h
--- include/pconn/PConnection.h	30 Nov 2003 17:19:34 -0000	1.37
+++ include/pconn/PConnection.h	5 Dec 2003 10:42:57 -0000
@@ -101,6 +101,8 @@
 	int fd;				/* File descriptor */
 	unsigned short flags;		/* Flags. See PCONNFL_*, above */
 
+	int bytes_read,bytes_write;
+	time_t start_time,stop_time;
 	/* The following io_* fields are really virtual functions that
 	 * allow you to choose between serial and USB I/O.
 	 */
Index: libpconn/PConnection.c
===================================================================
RCS file: /var/lib/cvs/coldsync/libpconn/PConnection.c,v
retrieving revision 1.35
diff -u -B -b -r1.35 PConnection.c
--- libpconn/PConnection.c	24 May 2003 18:06:03 -0000	1.35
+++ libpconn/PConnection.c	5 Dec 2003 10:42:57 -0000
@@ -13,6 +13,7 @@
 #include <unistd.h>
 #include <stdlib.h>
 #include <errno.h>
+#include <time.h>
 
 #ifndef HAVE_ENODEV
 #  define ENODEV	999	/* Some hopefully-impossible value */
@@ -90,6 +92,8 @@
 	pconn->io_private	= NULL;
 	pconn->whosonfirst	= 0;
 	pconn->speed		= -1;
+	pconn->bytes_read=0;
+	pconn->bytes_write=0;
 
 
 	/* Initialize callbacks */
@@ -169,6 +173,7 @@
 		return NULL;
 	}
 
+	time(&pconn->start_time);
 	PConn_set_status(pconn, PCONNSTAT_NONE);
 	
 	return pconn;
@@ -191,6 +196,8 @@
 	/* XXX - Why does this hang until the Palm times out, under
 	 * FreeBSD? (But only with 'xcopilot', it appears.)
 	 */
+	time(&pconn->stop_time);
+
 	IO_TRACE(4)
 		fprintf(stderr, "Calling io_drain()\n");
 
@@ -207,6 +214,9 @@
 	 * the pconn structure is going to be freed soon.
 	 */
 	PConn_set_status(pconn, PCONNSTAT_CLOSED);
+
+	IO_TRACE(1)
+		fprintf(stderr, "bytes read %d, read %d, time %f\n",pconn->bytes_read,pconn->bytes_write,difftime(pconn->stop_time,pconn->start_time));
 
 	/* Free the PConnection */
 	free(pconn);
Index: libpconn/PConnection_serial.c
===================================================================
RCS file: /var/lib/cvs/coldsync/libpconn/PConnection_serial.c,v
retrieving revision 1.44
diff -u -B -b -r1.44 PConnection_serial.c
--- libpconn/PConnection_serial.c	30 Nov 2003 17:19:33 -0000	1.44
+++ libpconn/PConnection_serial.c	5 Dec 2003 10:42:57 -0000
@@ -270,17 +270,28 @@
 static int
 serial_read(PConnection *p, unsigned char *buf, int len)
 {
-	return read(p->fd, buf, len);
+	int ret;
+
+	ret=read(p->fd, buf, len);
+	if (ret>0) p->bytes_read+=ret;
+	
+	return ret;
 }
 
 static int
 serial_write(PConnection *p, unsigned const char *buf, const int len)
 {
+	int ret;
+
 	if (p->fd == STDIN_FILENO) {
-	    return write(STDOUT_FILENO, buf, len);
+	    ret=write(STDOUT_FILENO, buf, len);
         } else {
-	    return write(p->fd, buf, len);
+	    ret=write(p->fd, buf, len);
 	}
+
+	if (ret>0) p->bytes_write+=ret;
+
+	return ret;
 }
 
 static int
